<?php

add_action( 'init', 'register_post_types' );
function register_post_types() {

	// Города
	$cities_args = [
		'label'              => 'Города',
		'public'             => true,
		'has_archive'        => false,
		'publicly_queryable' => false,
		'supports'           => [ 'title' ]
	];
	register_post_type( 'cities', $cities_args );

}

add_action( "admin_init", "cities_fields", 1 );
function cities_fields() {
	add_meta_box( "cities_eng_field", "На английском", "cities_eng_field", "cities", "normal", "high" );
	add_meta_box( "cities_padej1_field", "Предложный падеж", "cities_padej1_field", "cities", "normal", "high" );
	add_meta_box( "cities_padej2_field", "Дательный падеж", "cities_padej2_field", "cities", "normal", "high" );
	add_meta_box( "cities_padej3_field", "Родительный падеж", "cities_padej3_field", "cities", "normal", "high" );
	add_meta_box( "cities_phone_field", "Телефон", "cities_phone_field", "cities", "normal", "high" );
	add_meta_box( "cities_address_field", "Адрес", "cities_address_field", "cities", "normal", "high" );
	add_meta_box( "cities_addon_contacts_field", "Дополнительные точки", "cities_addon_contacts_field", "cities", "normal", "low" );
}

function cities_eng_field() {
	global $post;

	$custom   = get_post_custom( $post->ID );
	$city_eng = $custom["city_eng"][0];
	echo '<input type="text" style="width:100%;" name="city_eng" value="' . htmlentities( $city_eng ) . '">';

}

function cities_padej1_field() {
	global $post;

	$custom      = get_post_custom( $post->ID );
	$city_padej1 = $custom["city_padej1"][0];
	echo '<input type="text" style="width:100%;" name="city_padej1" value="' . htmlentities( $city_padej1 ) . '">';

}

function cities_padej2_field() {
	global $post;

	$custom      = get_post_custom( $post->ID );
	$city_padej2 = $custom["city_padej2"][0];
	echo '<input type="text" style="width:100%;" name="city_padej2" value="' . htmlentities( $city_padej2 ) . '">';

}

function cities_padej3_field() {
	global $post;

	$custom      = get_post_custom( $post->ID );
	$city_padej3 = $custom["city_padej3"][0];
	echo '<input type="text" style="width:100%;" name="city_padej3" value="' . htmlentities( $city_padej3 ) . '">';

}

function cities_phone_field() {
	global $post;

	$custom     = get_post_custom( $post->ID );
	$city_phone = $custom["city_phone"][0];
	echo '<input type="text" style="width:100%;" name="city_phone" value="' . htmlentities( $city_phone ) . '"><br>
	<sub>+7 (XXX) XXX-XX-XX</sub>';

}

function cities_address_field() {
	global $post;

	$custom       = get_post_custom( $post->ID );
	$city_address = $custom["city_address"][0];
	echo '<input type="text" style="width:100%;" name="city_address" value="' . htmlentities( $city_address ) . '">';

}

function cities_addon_contacts_field() {
	global $post;

	$custom              = get_post_custom( $post->ID );
	$city_addon_contacts = json_decode( $custom["city_addon_contacts"][0] );
	echo '<script>';
	echo 'jQuery(document).ready(function() {';
	echo ' jQuery(".remove-point").click(function(e) {';
	echo '	e.preventDefault();';
	echo '	jQuery(this).parent().parent().remove();';
	echo ' });';
	echo ' jQuery("#add_point_btn").click(function(e) {';
	echo '	e.preventDefault();';
	echo ' 	jQuery(".point_row:last-child").after("';
	echo '<tr class=\'point_row\'>';
	echo '<td><input placeholder=\'Название точки\' type=\'text\' style=\'width:100%;\' name=\'addon_contact_name[]\' value=\'\'></td>';
	echo '<td><input placeholder=\'Телефон точки\' type=\'text\' style=\'width:100%;\' name=\'addon_contact_phone[]\' value=\'\'></td>';
	echo '<td><input placeholder=\'Адрес точки\' type=\'text\' style=\'width:100%;\' name=\'addon_contact_address[]\' value=\'\'></td>';
	echo '<td><input placeholder=\'Режим работы точки\' type=\'text\' style=\'width:100%;\' name=\'addon_contact_time[]\' value=\'\'></td>';
	echo '<td style=\'text-align: right;\'><button style=\'color:red;border-color:red;\' class=\'button remove-point\'>Удалить</button></td>';
	echo '</tr>';
	echo '");';
	echo ' jQuery(".remove-point").click(function(e) {';
	echo '	e.preventDefault();';
	echo '	jQuery(this).parent().parent().remove();';
	echo ' });';
	echo ' });';
	echo '});';
	echo '</script>';
	echo '<table border="0" style="width:100%;">';
	if ( $city_addon_contacts ) {
		foreach ( $city_addon_contacts as $key => $value ) {
			echo '<tr class="point_row">';
			echo '<td><input placeholder="Название точки" type="text" style="width:100%;" name="addon_contact_name[]" value="' . base64_decode( $value->addon_contact_name ) . '"></td>';
			echo '<td><input placeholder="Телефон точки" type="text" style="width:100%;" name="addon_contact_phone[]" value="' . base64_decode( $value->addon_contact_phone ) . '"></td>';
			echo '<td><input placeholder="Адрес точки" type="text" style="width:100%;" name="addon_contact_address[]" value="' . base64_decode( $value->addon_contact_address ) . '"></td>';
			echo '<td><input placeholder="Режим работы точки" type="text" style="width:100%;" name="addon_contact_time[]" value="' . base64_decode( $value->addon_contact_time ) . '"></td>';
			echo '<td style="text-align: right;"><button style="color:red;border-color:red;" class="button remove-point">Удалить</button></td>';
			echo '</tr>';
		}
	} else {
		echo '<tr class="point_row">';
		echo '<td><input placeholder="Название точки" type="text" style="width:100%;" name="addon_contact_name[]" value=""></td>';
		echo '<td><input placeholder="Телефон точки" type="text" style="width:100%;" name="addon_contact_phone[]" value=""></td>';
		echo '<td><input placeholder="Адрес точки" type="text" style="width:100%;" name="addon_contact_address[]" value=""></td>';
		echo '<td><input placeholder="Режим работы точки" type="text" style="width:100%;" name="addon_contact_time[]" value=""></td>';
		echo '<td style="text-align: right;"><button style="color:red;border-color:red;" class="button remove-point">Удалить</button></td>';
		echo '</tr>';
	}
	echo '</table>';
	echo '<br>';
	echo '<div style="text-align:right;"><button id="add_point_btn" class="button button-small">Добавить точку</button></div>';

}

add_action( 'save_post', 'save_city', 0 );
function save_city( $post_id ) {

	global $post;
	//$wp_rewrite->flush_rules();

	if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) {
		return false;
	} // выходим если это автосохранение
	if ( ! current_user_can( 'edit_post', $post_id ) ) {
		return false;
	} // выходим если юзер не имеет право редактировать запись

	$city_addon_contacts = [];
	if ( ! empty( $_POST['addon_contact_name'][0] ) ) {
		foreach ( $_POST['addon_contact_name'] as $key => $addon_contact_name ) {
			$city_addon_contacts[] = [
				"addon_contact_name"    => base64_encode( $addon_contact_name ),
				"addon_contact_phone"   => base64_encode( $_POST['addon_contact_phone'][ $key ] ),
				"addon_contact_address" => base64_encode( $_POST['addon_contact_address'][ $key ] ),
				"addon_contact_time"    => base64_encode( $_POST['addon_contact_time'][ $key ] )
			];
		}
	}

	update_post_meta( $post->ID, "city_addon_contacts", json_encode( $city_addon_contacts ) );
	update_post_meta( $post->ID, "city_eng", html_entity_decode( $_POST["city_eng"] ) );
	update_post_meta( $post->ID, "city_padej1", html_entity_decode( $_POST["city_padej1"] ) );
	update_post_meta( $post->ID, "city_padej2", html_entity_decode( $_POST["city_padej2"] ) );
	update_post_meta( $post->ID, "city_padej3", html_entity_decode( $_POST["city_padej3"] ) );
	update_post_meta( $post->ID, "city_phone", html_entity_decode( $_POST["city_phone"] ) );
	update_post_meta( $post->ID, "city_address", html_entity_decode( $_POST["city_address"] ) );

}


add_action( 'wp_ajax_getpostscallback', 'get_posts_ajax_callback' );
function get_posts_ajax_callback() {
	$return         = array();
	$search_results = new WP_Query( array(
		's'                   => $_GET['q'],
		'post_status'         => 'publish',
		'ignore_sticky_posts' => 1,
		'posts_per_page'      => 50,
		'post_type'			  => 'post'
	) );
	if ( $search_results->have_posts() ) :
		while ( $search_results->have_posts() ) : $search_results->the_post();
			$title    = ( mb_strlen( $search_results->post->post_title ) > 50 ) ? mb_substr( $search_results->post->post_title, 0, 49 ) . '...' : $search_results->post->post_title;
			$return[] = array( $search_results->post->ID, $title );
		endwhile;
	endif;
	echo json_encode( $return );
	die;
}

add_action( 'wp_ajax_getpagescallback', 'get_pages_ajax_callback' );
function get_pages_ajax_callback() {
	$return         = array();
	$search_results = new WP_Query( array(
		'post_type'			  => 'page',
		'post_status'         => 'publish',
		'posts_per_page'      => -1,
		//'title' 			  => $_GET['q']
	) );
	if ( $search_results->have_posts() ) :
		while ( $search_results->have_posts() ) : $search_results->the_post();
			$title    = ( mb_strlen( $search_results->post->post_title ) > 50 ) ? mb_substr( $search_results->post->post_title, 0, 49 ) . '...' : $search_results->post->post_title;
			$return[] = array( $search_results->post->ID, $title );
		endwhile;
	endif;
	echo json_encode( $return );
	die;
}

add_action( 'wp_ajax_gettermscallback', 'get_terms_ajax_callback' );
function get_terms_ajax_callback() {
	$return         = array();
	$search_results = get_terms( array(
		'taxonomy'			  => 'category'
	) );
	if ( is_array($search_results) && count($search_results)>0 ) :
		foreach ( $search_results as $search_result ) {
			$title    = ( mb_strlen( $search_result->name ) > 50 ) ? mb_substr( $search_result->name, 0, 49 ) . '...' : $search_result->name;
			$return[] = array( $search_result->term_id, $title );
		}
	endif;
	echo json_encode( $return );
	die;
}


add_action( 'admin_enqueue_scripts', 'belingo_scripts_admin' );
function belingo_scripts_admin() {
	wp_enqueue_style( 'select2', 'https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.3/css/select2.min.css' );
	wp_enqueue_script( 'select2', 'https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.3/js/select2.min.js', array( 'jquery' ) );
	wp_enqueue_script( 'belingo-geo-scripts-admin', '/wp-content/plugins/belingoGeo/js/belingoGeoAdmin.js', array( 'jquery' ), '', false );
}

?>